bm::sv_serialization_plan_builder< SV > Class Template Reference
BitMagic Library » Task parallel programming

Parallel plan builder for succinct sparse vector serialization. More...

`#include <bmsparsevec_parallel.h>`

Collaboration diagram for bm::sv_serialization_plan_builder< SV >:
[legend]

## Data Structures

struct | serialization_params
struct | task_batch

## Public Types

typedef SV | sparse_vector_type
typedef SV::bvector_type | bvector_type
typedef SV::size_type | size_type
typedef bvector_type::allocator_type | allocator_type
typedef bm::bv_ref_vector< bvector_type > | bv_ref_vector_type
typedef bm::xor_sim_model< bvector_type > | xor_sim_model_type

## Public Member Functions

| sv_serialization_plan_builder ()
void | set_bookmarks (bool enable, unsigned bm_interval=256) BMNOEXCEPT
void | set_xor_ref (const bv_ref_vector_type *bv_ref_ptr) BMNOEXCEPT
void | set_sim_model (const xor_sim_model_type *sim_model) BMNOEXCEPT
void | build_plan (task_batch &batch, sparse_vector_serial_layout< SV > &sv_layout, const sparse_vector_type &sv)

## Static Protected Member Functions

static void * | task_run (void *argp)
| Task execution Entry Point.
static void * | task_run_final (void *argp)

## Protected Attributes

serialization_params | s_params_

## Detailed Description

template<typename SV>
class bm::sv_serialization_plan_builder< SV >

Parallel plan builder for succinct sparse vector serialization.

See also
  sparse_vector_serializer

Definition at line 162 of file bmsparsevec_parallel.h.

## Member Typedef Documentation

## allocator_type

template<typename SV>

typedef bvector_type::allocator_type bm::sv_serialization_plan_builder< SV >::allocator_type

Definition at line 168 of file bmsparsevec_parallel.h.

## bv_ref_vector_type

template<typename SV>

typedef bm::bv_ref_vector<bvector_type> bm::sv_serialization_plan_builder< SV >::bv_ref_vector_type

Definition at line 169 of file bmsparsevec_parallel.h.

## bvector_type

template<typename SV>

typedef SV::bvector_type bm::sv_serialization_plan_builder< SV >::bvector_type

Definition at line 166 of file bmsparsevec_parallel.h.

## size_type

template<typename SV>

typedef SV::size_type bm::sv_serialization_plan_builder< SV >::size_type

Definition at line 167 of file bmsparsevec_parallel.h.

## sparse_vector_type

template<typename SV>

typedef SV bm::sv_serialization_plan_builder< SV >::sparse_vector_type

Definition at line 165 of file bmsparsevec_parallel.h.

## xor_sim_model_type

template<typename SV>

typedef bm::xor_sim_model<bvector_type> bm::sv_serialization_plan_builder< SV >::xor_sim_model_type

Definition at line 170 of file bmsparsevec_parallel.h.

## Constructor & Destructor Documentation

## sv_serialization_plan_builder()

template<typename SV>

bm::sv_serialization_plan_builder< SV >::sv_serialization_plan_builder | ( |  | ) |

inline

Definition at line 199 of file bmsparsevec_parallel.h.

## Member Function Documentation

## build_plan()

template<typename SV>

void bm::sv_serialization_plan_builder< SV >::build_plan | ( | task_batch & | batch,
|  | sparse_vector_serial_layout< SV > & | sv_layout,
|  | const sparse_vector_type & | sv )

inline

Definition at line 212 of file bmsparsevec_parallel.h.

References bm::task_descr::barrier_ok, BM_ASSERT, bm::task_batch< BVAlloc >::get_task_vector(), bm::task_descr::init(), bm::sv_serialization_plan_builder< SV >::task_batch::s_params, s_params_, bm::sparse_vector_serial_layout< SV >::set_plane(), and bm::sv_serialization_plan_builder< SV >::serialization_params::sim_model_ptr_.

## set_bookmarks()

template<typename SV>

void bm::sv_serialization_plan_builder< SV >::set_bookmarks | ( | bool | enable,
|  | unsigned | bm_interval = 256 )

inline

Definition at line 202 of file bmsparsevec_parallel.h.

References BMNOEXCEPT, and s_params_.

## set_sim_model()

template<typename SV>

void bm::sv_serialization_plan_builder< SV >::set_sim_model | ( | const xor_sim_model_type * | sim_model | ) |

inline

Definition at line 208 of file bmsparsevec_parallel.h.

References BMNOEXCEPT, and s_params_.

## set_xor_ref()

template<typename SV>

void bm::sv_serialization_plan_builder< SV >::set_xor_ref | ( | const bv_ref_vector_type * | bv_ref_ptr | ) |

inline

Definition at line 205 of file bmsparsevec_parallel.h.

References BMNOEXCEPT, and s_params_.

## task_run()

template<typename SV>

void * bm::sv_serialization_plan_builder< SV >::task_run | ( | void * | argp | ) |

inline static protected

Task execution Entry Point.

Definition at line 279 of file bmsparsevec_parallel.h.

## task_run_final()

template<typename SV>

void * bm::sv_serialization_plan_builder< SV >::task_run_final | ( | void * | argp | ) |

inline static protected

Definition at line 287 of file bmsparsevec_parallel.h.

## Field Documentation

## s_params_

template<typename SV>

serialization_params bm::sv_serialization_plan_builder< SV >::s_params_

protected

Definition at line 295 of file bmsparsevec_parallel.h.

Referenced by build_plan(), set_bookmarks(), set_sim_model(), and set_xor_ref().

The documentation for this class was generated from the following file:

- bmsparsevec_parallel.h